import java.util.Arrays;
import java.util.List;

import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;

import com.jfkj.excelutil.ExcelUtil;
import com.jfkj.excelutil.Range;
import com.justep.model.ModelUtils;
import com.justep.system.data.KSQL;
import com.justep.system.data.Table;
import com.justep.system.util.CommonUtils;

public class Dj_ndtzwcbaProcess {

	public static void dj_ndtzwcbaProcessAfterImportExcelBeforeAction() {
		Workbook workBook = (Workbook) ModelUtils.getRequestContext().getActionContext().getParameter("excel");
		Sheet sheet = workBook.getSheetAt(0);
		String sheetName = sheet.getSheetName();
		if (!sheetName.equals("年度完成备案")) {
			throw new RuntimeException("温馨提示:请选择正确的excel模板导入数据！");
		}
		int lastRowNum = sheet.getLastRowNum();
		for (int i = 2; i <= lastRowNum; i++) {
			Row row = sheet.getRow(i);
			// 项目编码
			Cell fNDTZWCMX_XMBM = row.getCell(1);
			if (ExcelUtil.isCellEmpty(fNDTZWCMX_XMBM)) {
				throw new RuntimeException("第" + (i + 1) + "行项目编码不能为空！");
			}
			String ksql = "select TZ_XMXX,TZ_XMXX.fXMXX_XMBM,TZ_XMXX.fXMXX_XMMC from TZ_XMXX TZ_XMXX where TZ_XMXX.fDATASTATE = '0' and TZ_XMXX.fXMXX_ZXBB = '是' and TZ_XMXX.fXMXX_XMBM='"
					+ fNDTZWCMX_XMBM.getStringCellValue() + "'";
			Table table = KSQL.select(ksql, null, "/tzxt/tzxt/data", null);
			if (table.size() <= 0) {
				throw new RuntimeException("第" + (i + 1) + "行项目编码(" + fNDTZWCMX_XMBM.getStringCellValue()
						+ ")在项目库未找到，请检查此项目编码与项目库是否一致！");
			}
			// 项目名称
			Cell fNDTZWCMX_XMMC = row.getCell(2);
			if (ExcelUtil.isCellEmpty(fNDTZWCMX_XMMC)) {
				throw new RuntimeException("第" + (i + 1) + "行项目名称不能为空！");
			}
			// 项目名称与数据库比对
			com.justep.system.data.Row xmRow = table.getRow("fXMXX_XMBM", fNDTZWCMX_XMBM.getStringCellValue());
			String fXMXX_XMMC = xmRow.getString("fXMXX_XMMC");
			if (!fNDTZWCMX_XMMC.getStringCellValue().equals(fXMXX_XMMC)) {
				throw new RuntimeException("第" + (i + 1) + "行项目名称(" + fNDTZWCMX_XMMC.getStringCellValue()
						+ ")与项目库不一致，请检查此项目！");
			}
			// 类型
			Cell fLX = row.getCell(3);
			if (ExcelUtil.isCellEmpty(fLX)) {
				throw new RuntimeException("第" + (i + 1) + "行类型不能为空！");
			}
			// 类型值域判断
			List<String> wxlx = Range.getWclx();
			if (!wxlx.contains(fLX.getStringCellValue())) {
				throw new RuntimeException("第" + (i + 1) + "行建设状态填写有误！");
			}

			// 投资总金额
			Cell fXMXX_TZZE = row.getCell(4);
			if (ExcelUtil.isCellEmpty(fXMXX_TZZE)) {
				throw new RuntimeException("第" + (i + 1) + "行投资总额不能为空！");
			}
			// 自有资金
			Cell fNDTZWCMX_BNTZJEZY = row.getCell(5);
			if (ExcelUtil.isCellEmpty(fNDTZWCMX_BNTZJEZY)) {
				throw new RuntimeException("第" + (i + 1) + "行自有资金不能为空！");
			}
			// 银行贷款
			Cell fNDTZWCMX_BNTZJEDK = row.getCell(6);
			if (ExcelUtil.isCellEmpty(fNDTZWCMX_BNTZJEDK)) {
				throw new RuntimeException("第" + (i + 1) + "行银行贷款不能为空！");
			}
			// 直接融资
			Cell fNDTZWCMX_ZJRZ = row.getCell(7);
			if (ExcelUtil.isCellEmpty(fNDTZWCMX_ZJRZ)) {
				throw new RuntimeException("第" + (i + 1) + "行直接融资不能为空！");
			}
			// 政府补助
			Cell fNDTZWCMX_ZFBZ = row.getCell(8);
			if (ExcelUtil.isCellEmpty(fNDTZWCMX_ZFBZ)) {
				throw new RuntimeException("第" + (i + 1) + "行政府补助不能为空！");
			}
			// 其他
			Cell fNDTZWCMX_BNTZJEQT = row.getCell(9);
			if (ExcelUtil.isCellEmpty(fNDTZWCMX_BNTZJEQT)) {
				throw new RuntimeException("第" + (i + 1) + "行其他金额不能为空！");
			}

			// 是否完成
			Cell fNDTZWCMX_SFWC = row.getCell(12);
			if (ExcelUtil.isCellEmpty(fNDTZWCMX_SFWC)) {
				throw new RuntimeException("第" + (i + 1) + "行是否完成不能为空！");
			}
			// 截止上年累计投资额
			Cell fNDTZWCMX_JZSNLJTZE = row.getCell(13);
			if (ExcelUtil.isCellEmpty(fNDTZWCMX_JZSNLJTZE)) {
				throw new RuntimeException("第" + (i + 1) + "行截止上年累计投资额不能为空！");
			}

			// 累计投资金额
			Cell fNDTZWCMX_LJTZJE = row.getCell(14);
			if (ExcelUtil.isCellEmpty(fNDTZWCMX_LJTZJE)) {
				throw new RuntimeException("第" + (i + 1) + "行累计投资金额不能为空！");
			}

			// 本年计划投资额
			Cell fNDTZWCMX_BNJHTZE = row.getCell(15);
			if (ExcelUtil.isCellEmpty(fNDTZWCMX_BNJHTZE)) {
				throw new RuntimeException("第" + (i + 1) + "行本年计划投资额不能为空！");
			}
			// 项目类型
			Cell fXMXX_TZLX = row.getCell(16);
			if (ExcelUtil.isCellEmpty(fXMXX_TZLX)) {
				throw new RuntimeException("第" + (i + 1) + "行项目类型不能为空！");
			}

			List<String> tzlx = Range.getTzlx();
			if (!tzlx.contains(fXMXX_TZLX.getStringCellValue())) {
				throw new RuntimeException("第" + (i + 1) + "行项目类型填写有误！");
			}

			// 投资完成主表id
			Cell fNDTZWCMX_ZBID = row.getCell(17);
			if (ExcelUtil.isCellEmpty(fNDTZWCMX_ZBID)) {
				throw new RuntimeException("第" + (i + 1) + "行投资计划主表id不能为空！");
			}

			// 明细ID
			Cell mxID = row.createCell(18);
			mxID.setCellValue(CommonUtils.createGUID());
			// 项目ID
			String xmxxID = xmRow.getString("TZ_XMXX");
			Cell xmID = row.createCell(19);
			xmID.setCellValue(xmxxID);
		}
	
	}
}
