define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	require("css!$UI/system/components/justep/jedate/jedate").load();
	var jeDate = require("$UI/system/components/justep/jedate/jedate");
	var Model = function() {
		this.callParent();
		this.temArr = [];
	};

	//金额合计公式    mengjie 20210330
	Model.prototype.calculateTotal = function(data, col) {
		var jehj = data.sum(col);
		return jehj == 0 ? '0.00' : jehj;
	};

	//明细金额合计公式   
	Model.prototype.DetailCalculateTotal = function(param1, param2) {
		var sum = param1 + param2;
		if (isNaN(sum)) {
			return 0;
		}

		sum = sum.toFixed(2).toString();
		return sum;
	};

	Model.prototype.newBtnClick = function(event) {
		var mainData = this.comp("mainData");
		//页面只允许新增一次
		var newList = mainData.getChangedRows("new");
		if (newList.length > 0) {
			alert("请先保存之前新增的单据！");
			return;
		}
		mainData.newData({
			"index" : 0
		});//新增在第一行
		//设置默认值
		var date = justep.Date.now();
		var year = date.getFullYear() - 1;
		mainData.setValue("fNDTZWCZB_TZND", year);
		this.goTotab();
	};

	Model.prototype.goTotab = function() {
		var tabs = this.comp("tabs");
		tabs.setActiveTab("nav-detail");
	};

	Model.prototype.orderTablesRowDblClick = function(event) {
		var mainData = this.comp("mainData");
		mainData.to(event.bindingContext.$object);
		this.goTotab();
	};

	Model.prototype.DataSaveCommit = function(event) {
		if (this.status == 'summit') {
			justep.Util.hint("提交成功！", {
				type : 'success',
				parent : this.getRootNode()
			});
			this.status = 'save';
		} else if (this.status == 'del') {
			justep.Util.hint("删除成功！", {
				type : 'success',
				parent : this.getRootNode()
			});
			this.status = 'save';
		} else if (this.status == 'back') {
			justep.Util.hint("收回成功！", {
				type : 'success',
				parent : this.getRootNode()
			});
			this.status = 'save';
		} else {
			justep.Util.hint("保存成功！", {
				type : 'success',
				parent : this.getRootNode()
			});
		}
	};

	Model.prototype.checkboxPC1Change = function(event) {
		if (event.checked)
			$(this.getElementByXid("searchArea")).slideDown(300);
		else
			$(this.getElementByXid("searchArea")).slideUp(300);
	};

	Model.prototype.modelLoad = function(event) {
		var me = this;
		jeDate(this.getElementByXid("fNDTZWCZB_TZND"), {
			theme : {
				bgcolor : "#00A1CB",
				color : "#ffffff",
				pnColor : "#00CCFF"
			},
			format : "YYYY",
			clearfun : function(elem, val) {
				me.comp("fNDTZWCZB_TZND").val("");
			},
			donefun : function(obj) {
				// 获取当前input对象
				var val = obj.val;
				me.comp("fNDTZWCZB_TZND").val(val);
			}
		});

		//默认查询条件值
		var date = justep.Date.now();
		var year = date.getFullYear() - 1;
		this.comp("input1").val(year);

	};
	
	//查询按钮
	Model.prototype.button5Click = function(event) {
		var data = this.comp("mainData");
		var nd = this.comp("input1").get("value");
		var djzt = this.comp("select4").get("value");
		var filterName = '_like_filter_';
		var concept = "TZ_NDTZWCZB";

		var filterText = "";
		if (nd) {
			filterText += "(" + concept + ".fNDTZWCZB_TZND LIKE '%" + nd + "%') AND ";
		}
		if (djzt) {
			filterText += "(" + concept + ".fNDTZWCZB_DJZT LIKE '%" + djzt + "%') AND ";
		}
		
		filterText += " 1=1";
		data.filters.setFilter(filterName, filterText);
		data.refreshData();
	};
	
	Model.prototype.djztRefreshCreateParam = function(event) {
		var mapParam = new biz.Request.MapParam();
		mapParam.put("lxbm", "djzt");
		event.param.setMap("variables", mapParam);
	};
	
	//下载模板
	Model.prototype.button8Click = function(event) {
		//        提交前需要进行URL转换，在URL上补足bsessionid等必要信息
		var url = require.toUrl("$UI/tzxt/tzxt/process/dj_ndtzwcba/exportExcel.j?bsessionid="
				+ this.getContext().getBSessionID());
		var mainData = this.comp("mainData");
		var state = mainData.getRowState(mainData.getCurrentRow());
		if (state != "none") {
			alert("请先保存数据后,再导出EXCEL模板！");
			return;
		}

		var year = mainData.getValue("fNDTZWCZB_TZND");
		if (year === "") {
			alert("投资年度不能为空！");
			return;
		}
		var rowID = mainData.getCurrentRowID();
		var orgName = mainData.getValue("fSSZZ");
		if (typeof (rowID) == "undefined") {
			alert("请点击新建按钮后,再导出EXCEL模板！");
			return;
		}

		url = url + "&year=" + year + "&orgName=" + orgName + "&rowID=" + rowID;
		// 弹出下载
		//window.open(url);
		var fileIframe = document.createElement("iframe");
		document.body.appendChild(fileIframe);
		fileIframe.style.display = "none";
		fileIframe.src = url;
		document.body.removeAttribute(fileIframe);
	};

	//提交操作
	Model.prototype.button6Click = function(event) {
		var mainData = this.comp("mainData");
		var detailData = this.comp("detailData");
		var self = this;
		var djzt = mainData.getValue("fNDTZWCZB_DJZT");

		//防止未选择单据单点击按钮
		var mainID = mainData.getCurrentRowID();
		
		if (typeof (mainID) == "undefined") {
			alert("请选择需要提交的单据!");
			return;
		}

		if (djzt == "已提交" || djzt == "通过") {
			alert("当前单据状态:" + djzt + ",不能提交！");
			return;
		}

		var falg = false;
		//业务校验
		detailData.each(function(param) {
			//1、项目唯一，以项目编码判断为准
			var code = param.row.val('fNDTZWCMX_XMBM');
			var length = detailData.find([ "fNDTZWCMX_XMBM" ], [ code ]).length;
			if (length > 1) {
				alert("编码:" + code + "项目重复请检查数据！");
				falg = true;
				param.cancel = true;// 结束循环

			}

			var xh = param.row.val("fNDTZWCMX_XH");
			//2、是否完成必填
			var fNDTZWCMX_SFWC = param.row.val("fNDTZWCMX_SFWC");

			if (!fNDTZWCMX_SFWC) {
				alert("序号：" + xh + "的项目是否完成未填写，请检查！");
				falg = true;
				param.cancel = true;// 结束循环
			}

			var kgrq = param.row.val("fNDTZWCMX_SJKGRQ");
			var wgrq = param.row.val("fNDTZWCMX_SJWGRQ");

			if (fNDTZWCMX_SFWC === '是') {
				//完成项目，开工日期、完工日期必填
				if (self.isNull(kgrq) || self.isNull(wgrq)) {
					alert("序号：" + xh + "的项目开工时间、完成时间必填，请检查！");
					falg = true;
					param.cancel = true;// 结束循环
				}

			}

			if (kgrq > wgrq) {
				alert("序号：" + xh + "的项目开工时间应晚于完成时间，请检查！");
				falg = true;
				param.cancel = true;// 结束循环
			}
		});

		if (falg) {
			//结束方法
			return;
		}

		justep.Util.confirm("是否确定提交此信息？", function() {
			mainData.setValue("fNDTZWCZB_DJZT", "已提交");
			mainData.saveData({
				"onSuccess" : function(event) {
					self.status = 'summit';
					event.source.refreshData();
				}
			});
		});

	};

	//字符串非空判断
	Model.prototype.isNull = function(result) {
		var falg = false;
		if (result == null || result == '' || typeof (result) == "undefined") {
			falg = true;
		}
		return falg;
	};

	Model.prototype.button4Click = function(event) {
		var mainData = this.comp("mainData");
		var self = this;
		var djzt = mainData.getValue("fNDTZWCZB_DJZT");
		if (djzt == "已提交") {
			justep.Util.confirm("是否确定取消上报此信息？", function() {
				mainData.setValue("fNDTZWCZB_DJZT", "自由态");
				mainData.saveData({
					"onSuccess" : function(event) {
						self.status = 'back';
						event.source.refreshData();
					}
				});
			});
		} else if (djzt == "通过" || djzt == "驳回") {
			alert("单据状态为：" + djzt + "不能收回");
		} else {
			alert("已是自由态，无需收回");
		}
	};

	Model.prototype.smartFilter1Filter = function(event) {
		var mainData = this.comp("mainData");
		if (mainData.getRowState(mainData.getCurrentRow()) != 'none') {
			alert("请先保存数据，再查找项目！");
			return;
		}
		var data = event.source.getFilterData();
		var filter = event.source.getFilterStr();
		data.setFilter("filter", filter);
		data.refreshData();
	};

	Model.prototype.mainDataBeforeSave = function(event) {
		var detailData = this.comp("detailData");
		var mainData = this.comp("mainData");
		var flag = false;

		var count = detailData.count();
		if (count <= 0) {
			alert("提示:年度投资完成明细没有维护数据，请填报信息！");
			// 保存中断
			event.cancel = true;
		}

		//1、填报期间是否重复
		var whzz = mainData.getValue("fSSZZ");
		var state = event.source.getRowState(event.source.getCurrentRow());
		if (state == "new") {
			var repeat = this.comp("repeat");
			var nd = event.source.getValue("fNDTZWCZB_TZND");
			repeat.filters.setFilter("filter", " TZ_NDTZWCZB.fNDTZWCZB_TZND  ='" + nd
					+ "' and TZ_NDTZWCZB.fDATASTATE='0' and TZ_NDTZWCZB.fSSZZ='" + whzz + "' ");
			repeat.refreshData();
			if (repeat.count() > 0) {
				throw justep.Error.create(nd + "年数据已经填报，请重新选择填报的期间！");
			}
		}

	};

	Model.prototype.detailGridCellRender = function(event) {
		if (event.colName == "fNDTZWCMX_XMMC" && event.colVal != undefined) {//判断是不是需要换行显示的这列并且列是有值的
			event.html = "<div style='word-wrap:break-word; white-space:normal;'>" + event.colVal
					+ "</div>";//在div中显示列的值event.colVal
		}
		
		if (event.colName == "fNDTZWCMX_XMMC" && event.colVal != undefined) {//判断是不是需要换行显示的这列并且列是有值的
			event.html = "<div style='white-space: nowrap; overflow: hidden;text-overflow: ellipsis;'>" + event.colVal
					+ "</div>";//在div中显示列的值event.colVal
		}
	};

	//读取年度计划
	Model.prototype.button10Click = function(event) {
		var mainData = this.comp("mainData");
		var year = mainData.getValue("fNDTZWCZB_TZND");
		if (year === "") {
			alert("投资年度不能为空！");
			return;
		}

		var zbid = mainData.getCurrentRowID();
		if (typeof (zbid) == "undefined") {
			alert("请点击新建按钮！");
			return;
		}

		var djzt = mainData.getValue("fNDTZJHZB_DJZT");

		if (djzt == "已提交" || djzt == "通过") {
			alert("当前单据状态:" + djzt + ",不能点击按钮！");
			return;
		}

		var detailData = this.comp("detailData");
		//删除页面数据，防止多次点击按钮数据累加
		var confirmDelete = detailData.confirmDelete;
		try {
			detailData.confirmDelete = false;
			detailData.deleteAllData();
		} finally {
			detailData.confirmDelete = confirmDelete;
		}
		var detailGrid = this.comp("detailGrid");
		// 执行action
		var params = new biz.Request.ActionParam();
		params.setString("year", year);
		params.setString("zbID", zbid);
		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "DQNDJHAction",
			"parameters" : params,
			"callback" : function(data) {
				data.ignoreError = false;
				if (data.state) {
					detailData.loadData(data.response, true);
					detailData.first();
					//detailGrid.refresh();
				}
			}
		});
	};

	Model.prototype.button11Click = function(event) {
		var mainData = this.comp("mainData");
		var detailData = this.comp("detailData");
		var year = mainData.getValue("fNDTZWCZB_TZND");
		var djzt = mainData.getValue("fNDTZWCZB_DJZT");
		var zbid = mainData.getCurrentRowID();
		//逻辑检验
		if (typeof (zbid) == "undefined") {
			alert("请点击新建按钮！");
			return;
		}
		if (year === "") {
			alert("投资年度不能为空！");
			return;
		}
		if (djzt == "已提交" || djzt == "通过") {
			alert("当前单据状态:" + djzt + ",不能点击按钮！");
			return;
		}
		//删除页面数据，防止多次点击按钮数据累加
		var confirmDelete = detailData.confirmDelete;
		try {
			detailData.confirmDelete = false;
			detailData.deleteAllData();
		} finally {
			detailData.confirmDelete = confirmDelete;
		}

		// 执行action
		var params = new biz.Request.ActionParam();
		params.setString("year", year);
		params.setString("zbID", zbid);
		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "DQYBAction",
			"parameters" : params,
			"callback" : function(data) {
				data.ignoreError = false;
				if (data.state) {
					detailData.loadData(data.response);
					detailData.first();
				}
			}
		});

	};

	Model.prototype.importExcel1BeforeImport = function(event) {
		var detailData = this.comp("detailData");
		var self = this;
		this.temArr = [];
		detailData.each(function(param) {
			self.temArr.push(param.row);
		});

	};

	Model.prototype.importExcel1Success = function(event) {
		//增加判断成功条数数据
		var total = event.response.rows.length;
		if (total > 0) {
			var data = this.comp('detailData');
			var confirmDelete = data.confirmDelete;
			try {
				data.confirmDelete = false;
				data.deleteData(this.temArr);
			} finally {
				data.confirmDelete = confirmDelete;
			}
		}
		alert("导入成功" + total + "条！");
	};

	//明细删除后事件        2021-06-11
	Model.prototype.detailDataAfterDelete = function(event) {
		//重新生成序号
		var detailData = this.comp("detailData");
		var xh = 1001;
		detailData.each(function(param) {
			var row = param.row;
			row.val("fNDTZWCMX_XH", xh);
			xh++;
		});
	};

	//按钮禁用
	Model.prototype.buttondisable = function(event) {
		var falg = false;
		var mainData = this.comp("mainData");
		var djzt = mainData.getValue("fNDTZWCZB_DJZT");

		if (djzt == "通过" || djzt == "已提交") {
			falg = true;
		}
		return falg;
	};

	//明细data值变化方法   mengjie  20211224
	Model.prototype.detailDataValueChange = function(event) {
		//当金额字段为空，设置为0，防止计算公式有误
		if (event.col == 'fNDTZWCMX_BNTZJEZY' || event.col == 'fNDTZWCMX_BNTZJEDK'
				|| event.col == 'fNDTZWCMX_ZJRZ' || event.col == 'fNDTZWCMX_ZFBZ'
				|| event.col == 'fNDTZWCMX_BNTZJEQT') {
			if (event.newValue == '') {
				event.newValue = 0;
			}
		}
	};
	
	//项目弹出框选择事件	mengjie  20220318
	Model.prototype.xmxzDialogReceived = function(event){
		//重新生成序号
		var detailData = this.comp("detailData");
		var xh = 1001;
		detailData.each(function(param) {
			var row = param.row;
			row.val("fNDTZWCMX_XH", xh);
			xh++;
		});
	};
	return Model;
});
